(* ɽͥ *) 
module type Set_t = sig 
  type 'a t 
    (* Ǥη 'a νηȤ *) 
 
  val empty : 'a t 
    (* Ȥempty *) 
    (*  *) 
 
  val singleton : 'a -> 'a t 
    (* Ȥsingleton element *) 
    (* Ǥ element ҤȤĤʤ뽸֤ *) 
 
  val union : 'a t -> 'a t -> 'a t 
    (* Ȥunion set1 set2 *) 
    (*  set1  set2 ½֤ *) 
 
  val inter : 'a t -> 'a t -> 'a t 
    (* Ȥinter set1 set2 *) 
    (*  set1  set2 ζʬ֤ *) 
 
  val diff : 'a t -> 'a t -> 'a t 
    (* Ȥdiff set1 set2 *) 
    (*  set1  set2 Ǥʺˤ֤ *) 
 
  val mem : 'a -> 'a t -> bool 
    (* Ȥmem element set *) 
    (*  element  set äƤ뤫ɤ򿿵֤ͤ *) 
end 
 
(* Υ⥸塼롧ꥹ *) 
module Set : Set_t = struct 
  (* Ǥη 'a νηǤϥꥹȤȤäƤ뤬 *) 
  (* ڤʤɤȤȰʲΨŪ˼¸Ǥ褦ˤʤ *) 
  type 'a t = 'a list 
 
  (*  *) 
  (* empty : 'a t*) 
  let empty = [] 
 
  (* ŪǤ element ҤȤĤʤ뽸֤ *) 
  (* singleton : 'a -> 'a t *) 
  let singleton element = [element] 
 
  (* Ū set1  set2 ½֤ *) 
  (* union : 'a t -> 'a t -> 'a t *) 
  let union set1 set2 = set1 @ set2 
 
  (* Ū set1  set2 ζʬ֤ *) 
  (* inter : 'a t -> 'a t -> 'a t *) 
  let inter set1 set2 = 
    List.fold_left (fun lst element -> 
		      if List.mem element set2 then element :: lst else lst) 
		   [] set1 
 
  (* Ū set1  set2 Ǥʺˤ֤ *) 
  (* diff : 'a t -> 'a t -> 'a t *) 
  let diff set1 set2 = 
    List.fold_left (fun lst element -> 
		      if List.mem element set2 then lst else element :: lst) 
		   [] set1 
 
  (* Ū element  set äƤ뤫ɤ򿿵֤ͤ *) 
  (* mem : 'a -> 'a t -> bool *) 
  let mem element set = List.mem element set 
end 
