(* ҡפɽ⥸塼 *) 
 
(* ҡפźηΥ⥸塼ǤѹϤǤʤ *) 
type index_t = int ref 
 
(* Ǿͤͤ 'a  
   Τۤղþ 'b Ǥҡפη *) 
type ('a, 'b) t = int ref * (index_t * 'a * 'b) array 
 
(* insert Ȥ˥ҡפդ raise 㳰 *) 
exception Full 
 
(* split_top Ȥ˥ҡפ raise 㳰 *) 
exception Empty 
 
(* index_t ĥߡ *) 
let example_index = ref (-1) 
 
(* ͤ example_value Ʊղþ example_info Ʊ 
    max ĤǤǼǤҡפ֤ *) 
let create max example_value example_info = 
  (ref 0, Array.make max (example_index, example_value, example_info)) 
 
(* current_index  parent_index Ǥ촹 *) 
let swap array current_index parent_index = 
  let (index_ref_c, value_c, info_c) as entry_c = array.(current_index) in 
  let (index_ref_p, value_p, info_p) as entry_p = array.(parent_index) 
  in array.(current_index) <- entry_p; 
     array.(parent_index) <- entry_c; 
     index_ref_c := parent_index;  (* 촹ˤȤʤä index դѤ *) 
     index_ref_p := current_index; 
     () 
 
(* ˸äƥҡפξ褦Ǥ촹Ԥ *) 
let rec adjust_child num array current_index = 
  if current_index >= num then () 
  else let (_, v, _) = array.(current_index) in 
       let child1_index = 2 * current_index + 1 in 
       let child2_index = child1_index + 1 in 
       if child1_index >= num 
       then () 
       else let (_, v1, _) = array.(child1_index) in 
	    if child2_index >= num 
	    then if v <= v1 
		 then () 
		 else (swap array current_index child1_index; 
		       adjust_child num array child1_index) 
	    else let (_, v2, _) = array.(child2_index) in 
		 if v <= v1 && v <= v2 
		 then () 
		 else if v1 < v2 
		      then (swap array current_index child1_index; 
			    adjust_child num array child1_index) 
		      else (swap array current_index child2_index; 
			    adjust_child num array child2_index) 
 
(* ˸äƥҡפξ褦Ǥ촹Ԥ *) 
let rec adjust_parent array current_index = 
  if current_index = 0 then () 
  else let (_, value_c, _) = array.(current_index) in 
       let parent_index = (current_index - 1) /2 in 
       let (_, value_p, _) = array.(parent_index) in 
       if value_c < value_p 
       then (swap array current_index parent_index; 
	     adjust_parent array parent_index) 
       else () 
 
(* ҡפ˿Ǥɲä *) 
(* ʾ塢ʤȤ Full  raise  *) 
(* ҡפϡ˲Ūˡ˽Ѥ *) 
let insert (num_ref, array) v info = 
  if !num_ref >= Array.length array 
  then raise Full 
  else let index = ref !num_ref in 
       array.(!num_ref) <- (index, v, info); 
       adjust_parent array !num_ref; 
       num_ref := !num_ref + 1; 
       (index, (num_ref, array)) 
 
(* ҡפ !index_ref ܤǤ֤ *) 
(* index ̵Ǥ Not_found  raise  *) 
let get (num_ref, array) index_ref = 
  if 0 <= !index_ref && !index_ref < !num_ref 
  then let (_, a, b) = array.(!index_ref) in 
       (a, b) 
  else raise Not_found 
 
(* ҡפ !index_ref ܤͤ򹹿ҡפ֤ *) 
(* ҡפϡ˲Ūˡ˽Ѥ *) 
let set (num_ref, array) index_ref v info = 
  let (_, v', _) = array.(!index_ref) 
  in array.(!index_ref) <- (index_ref, v, info); 
     if v < v' then adjust_parent array !index_ref 
	       else adjust_child !num_ref array !index_ref; 
     (num_ref, array) 
 
(* ǾͤĤΤȤҡפΥڥ֤ *) 
(* ǾͤĤΤ index ̵ͤˤʤ *) 
(* ҡפΤȤ Empty  raise  *) 
(* ҡפϡ˲Ūˡ˽Ѥ *) 
let split_top (num_ref, array) = 
  if !num_ref = 0 then raise Empty else 
  let (index_ref, v, info) = array.(0) 
  in num_ref := !num_ref - 1;	(* ǿҤȤĸ餹 *) 
     swap array 0 !num_ref; 
     adjust_child !num_ref array 0; 
     index_ref := -1;        (* ФƬǤ index_ref ̵ˤ *) 
     ((v, info), (num_ref, array)) 
 
(* ҡΥǡο֤ *) 
let length (num_ref, _) = !num_ref 
